Smallest subarray having an element with frequency greater than that of other elements
Last Updated :
01 Feb, 2023
Given an array arr of positive integers, the task is to find the smallest length subarray of length more than 1 having an element occurring more times than any other element.
Examples:
Input: arr[] = {2, 3, 2, 4, 5}
Output: 2 3 2
Explanation: The subarray {2, 3, 2} has an element 2 which occurs more number of times any other element in the subarray.
Input: arr[] = {2, 3, 4, 5, 2, 6, 7, 6}
Output: 6 7 6
Explanation: The subarrays {2, 3, 4, 5, 2} and {6, 7, 6} contain an element that occurs more number of times than any other element in them. But the subarray {6, 7, 6} is of minimum length.
Naive Approach: A naive approach to solve the problem can be to find all the subarrays which have an element that meets the given condition and then find the minimum of all those subarrays.
- Initialize a variable result to the maximum possible value of an integer and a hash map unmap to store element frequencies. Initialize two variables maxFreq and secondMaxx to store the maximum and second maximum frequencies seen so far in the current subarray.
- Iterate through the input array arr[] with an outer loop variable i.
- For each value of i, iterate through the array again with an inner loop variable j such that j starts at i and goes up to the end of the array.
- For each value of j, increment the frequency of arr[j] in the hash map unmap.
- If the frequency of arr[j] in unmap is greater than the current value of maxFreq, update secondMaxx with the current value of maxFreq and maxFreq with the frequency of arr[j] in unmap.
- If the current subarray (from i to j) has at least two elements and both maxFreq and secondMaxx are greater than 0, update result with the minimum of its current value and the length of the current subarray.
- After the outer loop finishes, print the final value of result.
Below is the implementation of the above approach:
C++
// C++ program for the above approach
#include <bits/stdc++.h>
using namespace std;
// Function to find subarray
void FindSubarray(int arr[], int n)
{
// initialize result as the maximum possible value
int result = INT_MAX;
// iterate through all subarrays starting from index i
for (int i = 0; i < n; i++) {
// unordered_map to store element frequencies
unordered_map<int, int> unmap;
// variables to store maximum and second
// maximum frequency elements
int secondMaxx = -1;
int maxFreq = -1;
// iterate through all subarrays ending at index j
for (int j = i; j < n; j++) {
// increment the frequency of element arr[j] in
// the unordered_map
unmap[arr[j]]++;
// if the frequency of arr[j] is greater than
// maxFreq, update secondMaxx and maxFreq
if (unmap[arr[j]] > maxFreq) {
secondMaxx = maxFreq;
maxFreq = unmap[arr[j]];
}
// if the frequency of arr[j] is less than
// maxFreq but greater than secondMaxx, update
// secondMaxx
else if (unmap[arr[j]] > secondMaxx) {
secondMaxx = unmap[arr[j]];
}
// if the subarray has more than one element and
// both maxFreq and secondMaxx are greater than
// 0, update the result with the length of the
// current subarray
if (j - i + 1 > 1 && maxFreq > 0
&& secondMaxx > 0) {
result = min(j - i + 1, result);
}
}
}
// print the smallest subarray length
cout << result;
}
// Driver Code
int main()
{
int arr[] = { 2, 3, 4, 5, 2, 6, 7, 6 };
int n = sizeof(arr) / sizeof(arr[0]);
FindSubarray(arr, n);
return 0;
}
Java
import java.util.HashMap;
public class Gfg {
public static void FindSubarray(int[] arr, int n) {
// initialize result as the maximum possible value
int result = Integer.MAX_VALUE;
// iterate through all subarrays starting from index i
for (int i = 0; i < n; i++) {
// HashMap to store element frequencies
HashMap<Integer, Integer> hmap = new HashMap<>();
// variables to store maximum and second
// maximum frequency elements
int secondMaxx = -1;
int maxFreq = -1;
// iterate through all subarrays ending at index j
for (int j = i; j < n; j++) {
// increment the frequency of element arr[j] in
// the HashMap
if(hmap.containsKey(arr[j])) {
hmap.put(arr[j], hmap.get(arr[j]) + 1);
} else {
hmap.put(arr[j], 1);
}
// if the frequency of arr[j] is greater than
// maxFreq, update secondMaxx and maxFreq
if (hmap.get(arr[j]) > maxFreq) {
secondMaxx = maxFreq;
maxFreq = hmap.get(arr[j]);
}
// if the frequency of arr[j] is less than
// maxFreq but greater than secondMaxx, update
// secondMaxx
else if (hmap.get(arr[j]) > secondMaxx) {
secondMaxx = hmap.get(arr[j]);
}
// if the subarray has more than one element and
// both maxFreq and secondMaxx are greater than
// 0, update the result with the length of the
// current subarray
if (j - i + 1 > 1 && maxFreq > 0
&& secondMaxx > 0) {
result = Math.min(j - i + 1, result);
}
}
}
// print the smallest subarray length
System.out.println(result);
}
public static void main(String[] args) {
int[] arr = { 2, 3, 4, 5, 2, 6, 7, 6 };
int n = arr.length;
FindSubarray(arr, n);
}
}
Python3
# Function to find subarray
def FindSubarray(arr, n):
# initialize result as the maximum possible value
result = float('inf')
# iterate through all subarrays starting from index i
for i in range(n):
# dictionary to store element frequencies
unmap = {}
# variables to store maximum and second
# maximum frequency elements
secondMaxx = -1
maxFreq = -1
# iterate through all subarrays ending at index j
for j in range(i, n):
# increment the frequency of element arr[j] in
# the dictionary
if arr[j] in unmap:
unmap[arr[j]] += 1
else:
unmap[arr[j]] = 1
# if the frequency of arr[j] is greater than
# maxFreq, update secondMaxx and maxFreq
if unmap[arr[j]] > maxFreq:
secondMaxx = maxFreq
maxFreq = unmap[arr[j]]
# if the frequency of arr[j] is less than
# maxFreq but greater than secondMaxx, update
# secondMaxx
elif unmap[arr[j]] > secondMaxx:
secondMaxx = unmap[arr[j]]
# if the subarray has more than one element and
# both maxFreq and secondMaxx are greater than
# 0, update the result with the length of the
# current subarray
if j - i + 1 > 1 and maxFreq > 0 and secondMaxx > 0:
result = min(j - i + 1, result)
# print the smallest subarray length
print(result)
# Driver Code
arr = [2, 3, 4, 5, 2, 6, 7, 6]
n = len(arr)
FindSubarray(arr, n)
# This code is contributed by divya_p123.
C#
using System;
using System.Collections.Generic;
class Program {
// Function to find subarray
static void FindSubarray(int[] arr, int n)
{
// initialize result as the maximum possible value
int result = int.MaxValue;
// iterate through all subarrays starting from index
// i
for (int i = 0; i < n; i++) {
// unordered_map to store element frequencies
Dictionary<int, int> unmap
= new Dictionary<int, int>();
// variables to store maximum and second
// maximum frequency elements
int secondMaxx = -1;
int maxFreq = -1;
// iterate through all subarrays ending at index
// j
for (int j = i; j < n; j++) {
// increment the frequency of element arr[j]
// in the unordered_map
if (!unmap.ContainsKey(arr[j])) {
unmap.Add(arr[j], 1);
}
else {
unmap[arr[j]]++;
}
// if the frequency of arr[j] is greater
// than maxFreq, update secondMaxx and
// maxFreq
if (unmap[arr[j]] > maxFreq) {
secondMaxx = maxFreq;
maxFreq = unmap[arr[j]];
}
// if the frequency of arr[j] is less than
// maxFreq but greater than secondMaxx,
// update secondMaxx
else if (unmap[arr[j]] > secondMaxx) {
secondMaxx = unmap[arr[j]];
}
// if the subarray has more than one element
// and both maxFreq and secondMaxx are
// greater than 0, update the result with
// the length of the current subarray
if (j - i + 1 > 1 && maxFreq > 0
&& secondMaxx > 0) {
result = Math.Min(j - i + 1, result);
}
}
}
// print the smallest subarray length
Console.WriteLine(result);
}
// Driver Code
static void Main()
{
int[] arr = { 2, 3, 4, 5, 2, 6, 7, 6 };
int n = arr.Length;
FindSubarray(arr, n);
}
}
JavaScript
// JavaScript code equivalent to the C++ program
// Function to find subarray
const FindSubarray = (arr, n) => {
// initialize result as the maximum possible value
let result = Number.MAX_SAFE_INTEGER;
// iterate through all subarrays starting from index i
for (let i = 0; i < n; i++) {
// Map to store element frequencies
let unmap = new Map();
// variables to store maximum and second
// maximum frequency elements
let secondMaxx = -1;
let maxFreq = -1;
// iterate through all subarrays ending at index j
for (let j = i; j < n; j++) {
// increment the frequency of element arr[j] in
// the Map
unmap.set(arr[j], (unmap.get(arr[j]) || 0) + 1);
// if the frequency of arr[j] is greater than
// maxFreq, update secondMaxx and maxFreq
if (unmap.get(arr[j]) > maxFreq) {
secondMaxx = maxFreq;
maxFreq = unmap.get(arr[j]);
}
// if the frequency of arr[j] is less than
// maxFreq but greater than secondMaxx, update
// secondMaxx
else if (unmap.get(arr[j]) > secondMaxx) {
secondMaxx = unmap.get(arr[j]);
}
// if the subarray has more than one element and
// both maxFreq and secondMaxx are greater than
// 0, update the result with the length of the
// current subarray
if (j - i + 1 > 1 && maxFreq > 0 && secondMaxx > 0) {
result = Math.min(j - i + 1, result);
}
}
}
// print the smallest subarray length
console.log(result);
};
// Driver Code
const arr = [2, 3, 4, 5, 2, 6, 7, 6];
const n = arr.length;
FindSubarray(arr, n);
Time Complexity: O(N2)
Auxiliary Space: O(N)
Efficient Approach: The problem can be reduced to find out that if there is any element occurring twice in a subarray, then it can be a potential answer. Because the minimum length of such subarray can be the minimum distance between two same elements
The idea is to use an extra array that maintains the last occurrence of the elements in the given array. Then find the distance between the last occurrence of an element and current position and find the minimum of all such lengths.
Below is the implementation of the above approach.
C++
// C++ program for the above approach
#include <bits/stdc++.h>
using namespace std;
// Function to find subarray
void FindSubarray(int arr[], int n)
{
// If the array has only one element,
// then there is no answer.
if (n == 1) {
cout << "No such subarray!"
<< endl;
}
// Array to store the last occurrences
// of the elements of the array.
int vis[n + 1];
memset(vis, -1, sizeof(vis));
vis[arr[0]] = 0;
// To maintain the length
int len = INT_MAX, flag = 0;
// Variables to store
// start and end indices
int start, end;
for (int i = 1; i < n; i++) {
int t = arr[i];
// Check if element is occurring
// for the second time in the array
if (vis[t] != -1) {
// Find distance between last
// and current index
// of the element.
int distance = i - vis[t] + 1;
// If the current distance
// is less than len
// update len and
// set 'start' and 'end'
if (distance < len) {
len = distance;
start = vis[t];
end = i;
}
flag = 1;
}
// Set the last occurrence
// of current element to be 'i'.
vis[t] = i;
}
// If flag is equal to 0,
// it means there is no answer.
if (flag == 0)
cout << "No such subarray!"
<< endl;
else {
for (int i = start; i <= end; i++)
cout << arr[i] << " ";
}
}
// Driver Code
int main()
{
int arr[] = { 2, 3, 2, 4, 5 };
int n = sizeof(arr) / sizeof(arr[0]);
FindSubarray(arr, n);
return 0;
}
Java
// Java program for the above approach
import java.util.*;
class GFG{
// Function to find subarray
public static void FindSubarray(int[] arr,
int n)
{
// If the array has only one element,
// then there is no answer.
if (n == 1)
{
System.out.println("No such subarray!");
}
// Array to store the last occurrences
// of the elements of the array.
int[] vis = new int[n + 1];
Arrays.fill(vis, -1);
vis[arr[0]] = 0;
// To maintain the length
int len = Integer.MAX_VALUE, flag = 0;
// Variables to store
// start and end indices
int start = 0, end = 0;
for(int i = 1; i < n; i++)
{
int t = arr[i];
// Check if element is occurring
// for the second time in the array
if (vis[t] != -1)
{
// Find distance between last
// and current index
// of the element.
int distance = i - vis[t] + 1;
// If the current distance
// is less than len
// update len and
// set 'start' and 'end'
if (distance < len)
{
len = distance;
start = vis[t];
end = i;
}
flag = 1;
}
// Set the last occurrence
// of current element to be 'i'.
vis[t] = i;
}
// If flag is equal to 0,
// it means there is no answer.
if (flag == 0)
System.out.println("No such subarray!");
else
{
for(int i = start; i <= end; i++)
System.out.print(arr[i] + " ");
}
}
// Driver code
public static void main(String[] args)
{
int arr[] = { 2, 3, 2, 4, 5 };
int n = arr.length;
FindSubarray(arr, n);
}
}
// This code is contributed by divyeshrabadiya07
Python3
# Python3 program for the above approach
import sys
# Function to find subarray
def FindSubarray(arr, n):
# If the array has only one element,
# then there is no answer.
if (n == 1):
print("No such subarray!")
# Array to store the last occurrences
# of the elements of the array.
vis = [-1] * (n + 1)
vis[arr[0]] = 0
# To maintain the length
length = sys.maxsize
flag = 0
for i in range(1, n):
t = arr[i]
# Check if element is occurring
# for the second time in the array
if (vis[t] != -1):
# Find distance between last
# and current index
# of the element.
distance = i - vis[t] + 1
# If the current distance
# is less than len
# update len and
# set 'start' and 'end'
if (distance < length):
length = distance
start = vis[t]
end = i
flag = 1
# Set the last occurrence
# of current element to be 'i'.
vis[t] = i
# If flag is equal to 0,
# it means there is no answer.
if (flag == 0):
print("No such subarray!")
else:
for i in range(start, end + 1):
print(arr[i], end = " ")
# Driver Code
if __name__ == "__main__":
arr = [ 2, 3, 2, 4, 5 ]
n = len(arr)
FindSubarray(arr, n)
# This code is contributed by chitranayal
C#
// C# program for the above approach
using System;
class GFG{
// Function to find subarray
public static void FindSubarray(int[] arr,
int n)
{
// If the array has only one element,
// then there is no answer.
if (n == 1)
{
Console.WriteLine("No such subarray!");
}
// Array to store the last occurrences
// of the elements of the array.
int[] vis = new int[n + 1];
for(int i = 0; i < n + 1; i++)
vis[i] = -1;
vis[arr[0]] = 0;
// To maintain the length
int len = int.MaxValue, flag = 0;
// Variables to store
// start and end indices
int start = 0, end = 0;
for(int i = 1; i < n; i++)
{
int t = arr[i];
// Check if element is occurring
// for the second time in the array
if (vis[t] != -1)
{
// Find distance between last
// and current index
// of the element.
int distance = i - vis[t] + 1;
// If the current distance
// is less than len
// update len and
// set 'start' and 'end'
if (distance < len)
{
len = distance;
start = vis[t];
end = i;
}
flag = 1;
}
// Set the last occurrence
// of current element to be 'i'.
vis[t] = i;
}
// If flag is equal to 0,
// it means there is no answer.
if (flag == 0)
Console.WriteLine("No such subarray!");
else
{
for(int i = start; i <= end; i++)
Console.Write(arr[i] + " ");
}
}
// Driver code
public static void Main(String[] args)
{
int []arr = { 2, 3, 2, 4, 5 };
int n = arr.Length;
FindSubarray(arr, n);
}
}
// This code is contributed by sapnasingh4991
JavaScript
<script>
// Javascript program for the above approach
// Function to find subarray
function FindSubarray(arr, n)
{
// If the array has only one element,
// then there is no answer.
if (n == 1)
{
document.write("No such subarray!");
}
// Array to store the last occurrences
// of the elements of the array.
let vis = new Array(n + 1);
for(let i = 0; i < (n + 1); i++)
vis[i] = -1;
vis[arr[0]] = 0;
// To maintain the length
let len = Number.MAX_VALUE, flag = 0;
// Variables to store
// start and end indices
let start = 0, end = 0;
for(let i = 1; i < n; i++)
{
let t = arr[i];
// Check if element is occurring
// for the second time in the array
if (vis[t] != -1)
{
// Find distance between last
// and current index
// of the element.
let distance = i - vis[t] + 1;
// If the current distance
// is less than len
// update len and
// set 'start' and 'end'
if (distance < len)
{
len = distance;
start = vis[t];
end = i;
}
flag = 1;
}
// Set the last occurrence
// of current element to be 'i'.
vis[t] = i;
}
// If flag is equal to 0,
// it means there is no answer.
if (flag == 0)
document.write("No such subarray!");
else
{
for(let i = start; i <= end; i++)
document.write(arr[i] + " ");
}
}
// Driver code
let arr = [ 2, 3, 2, 4, 5 ];
let n = arr.length;
FindSubarray(arr, n);
// This code is contributed by avanitrachhadiya2155
</script>
Time Complexity: O(N), where n is the length of the array.
Auxiliary Space: O(N).
Similar Reads
Sum of elements in an array with frequencies greater than or equal to that element
Given an array arr[] of N integers. The task is to find the sum of the elements which have frequencies greater than or equal to that element in the array. Examples: Input: arr[] = {2, 1, 1, 2, 1, 6} Output: 3 The elements in the array are {2, 1, 6} Where, 2 appear 2 times which is greater than equal
9 min read
Smallest subarray such that all elements are greater than K
Given an array of N integers and a number K, the task is to find the length of the smallest subarray in which all the elements are greater than K. If there is no such subarray possible, then print -1. Examples: Input: a[] = {3, 4, 5, 6, 7, 2, 10, 11}, K = 5 Output: 1 The subarray is {10} Input: a[]
4 min read
Count of strings to be concatenated with a character having frequency greater than sum of others
Given an array arr[] containing N strings, the task is to find the maximum number of strings that can be concatenated such that one character has a frequency greater than the sum of the frequencies of all others. Example: Input: arr[]: {"qpr, "pppsp, "t"}Output: 3Explanation: Concatenate all 3 strin
9 min read
Largest subarray with frequency of all elements same
Given an array arr[] of N integers, the task is to find the size of the largest subarray with frequency of all elements the same. Examples: Input: arr[] = {1, 2, 2, 5, 6, 5, 6} Output: 6 Explanation: The subarray = {2, 2, 5, 6, 5, 6} has frequency of every element is 2. Input: arr[] = {1, 1, 1, 1, 1
15+ min read
Size of smallest subarray to be removed to make count of array elements greater and smaller than K equal
Given an integer K and an array arr[] consisting of N integers, the task is to find the length of the subarray of smallest possible length to be removed such that the count of array elements smaller than and greater than K in the remaining array are equal. Examples: Input: arr[] = {5, 7, 2, 8, 7, 4,
10 min read
Smallest subarray with all occurrences of a most frequent element
Given an array, A. Let x be an element in the array. x has the maximum frequency in the array. Find the smallest subsegment of the array which also has x as the maximum frequency element. Examples: Input : arr[] = {4, 1, 1, 2, 2, 1, 3, 3} Output : 1, 1, 2, 2, 1 The most frequent element is 1. The sm
8 min read
Total count of elements having frequency one in each Subarray
Given an array arr[] of length N, the task is to find the total number of elements that has frequency 1 in a subarray of the given array. Examples: Input: N = 3, arr[ ] = {2, 4, 2}Output: 8Explanation: All possible subarrays are {2}: elements with frequency one = 1.{4}: elements with frequency one =
13 min read
Length of smallest Subarray with at least one element repeated K times
Given an array arr[] of length N and an integer K. The task is to find the minimum length of subarray such that at least one element of the subarray is repeated exactly K times in that subarray. If no such subarray exists, print -1. Examples: Input: arr[] = {1, 2, 1, 2, 1}, K = 2Output: 3Explanation
9 min read
Smallest subarray with sum greater than or equal to K
Given an array A[] consisting of N integers and an integer K, the task is to find the length of the smallest subarray with sum greater than or equal to K. If no such subarray exists, print -1. Examples: Input: A[] = {2, -1, 2}, K = 3 Output: 3 Explanation: Sum of the given array is 3. Hence, the sm
15+ min read
Replace every element with the smallest of all other array elements
Given an array arr[] which consist of N integers, the task is to replace every element by the smallest of all other elements present in the array. Examples: Input: arr[] = {1, 1, 1, 2} Output: 1 1 1 1 Input: arr[] = {4, 2, 1, 3} Output: 1 1 2 1 Naive Approach: The simplest approach is to find the sm
12 min read